/* Custom mainline for macros */
     call RXFuncAdd "VRLoadFuncs", "VROBJ", "VRLoadFuncs"
     call VRLoadFuncs 
/*:VRX         Main
*/
/*  Main
*/
Main:
/*  Process the arguments.
    Get the parent window.
*/
    parse source . calledAs .
    parent = ""
    argCount = arg()
    argOff = 0
    if( calledAs \= "COMMAND" )then do
        if argCount >= 1 then do
            parent = arg(1)
            argCount = argCount - 1
            argOff = 1
        end
    end
    InitArgs.0 = argCount
    if( argCount > 0 )then do i = 1 to argCount
        InitArgs.i = arg( i + argOff )
    end
    drop calledAs argCount argOff

/*  Load the windows
*/
    call VRInit
    parse source . . spec
    _VREPrimaryWindowPath = ,
        VRParseFileName( spec, "dpn" ) || ".VRW"
    _VREPrimaryWindow = ,
        VRLoad( parent, _VREPrimaryWindowPath )
    drop parent spec
    if( _VREPrimaryWindow == "" )then do
        call VRMessage "", "Cannot load window:" VRError(), ,
            "Error!"
        _VREReturnValue = 32000
        signal _VRELeaveMain
    end

/*  Process events
*/
    call Init
    signal on halt
    do while( \ VRGet( _VREPrimaryWindow, "Shutdown" ) )
        _VREEvent = VREvent()
        interpret _VREEvent
    end
_VREHalt:
    _VREReturnValue = Fini()
    call VRDestroy _VREPrimaryWindow
_VRELeaveMain:
    call VRFini
/*exit _VREReturnValue*/
exit(str1','str2','str3','str4','str5','str6','str7','str8',')

VRLoadSecondary: procedure
    name = arg( 1 )

    window = VRLoad( VRWindow(), VRWindowPath(), name )
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
return window

/*:VRX         Fini
*/
Fini:
    window = VRWindow()
    call VRSet window, "Visible", 0
    drop window
return 0

/*:VRX         Halt
*/
Halt:
    signal _VREHalt
return

/*:VRX         Init
*/
Init:
    window = VRWindow()
    call VRMethod window, "CenterWindow"
    call VRSet window, "Visible", 1
    call VRMethod window, "Activate"
    drop window
    
    PATH = "C:\SYSTEM\LETTERS.TXT"
    OK = VRDELETEFILE(PATH)

    I = 1
    DO WHILE I <= 100
        OK = VRMETHOD("PASSES", "ADDSTRING", I)
        I = I + 1
    END   

return

/*:VRX         PB_1_Click
*/
PB_1_Click:

FLAGIT = 0

STR1 = VRGET("MATERIAL", "VALUE")
PATH = "C:\SYSTEM\LETTERS.TXT"
THE_TEXT = VRGET("LETTERS", "VALUE")
LETTER_LENGTH = LENGTH(THE_TEXT)

IF LETTER_LENGTH = 0 THEN DO
    OK = VRMESSAGE("WINDOW1", "You must enter at least one machinable character! Choose the 'Machinable Characters' button to see a list of all supported characters.   ", "Nothing to Machine!", "W")
    RETURN
END


COUNTER = 1
DO WHILE COUNTER <= LETTER_LENGTH
    TEMP = SUBSTR(THE_TEXT, COUNTER, 1)
    CHECKIT = TEMP
    IF TEMP = " " THEN DO
        TEMP = "^"
    END

    ELSE

    IF CHECKIT = "a" | CHECKIT = "b" | CHECKIT = "c" | CHECKIT = "d" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "e" | CHECKIT = "f" | CHECKIT = "g" | CHECKIT = "h" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "i" | CHECKIT = "j" | CHECKIT = "k" | CHECKIT = "l" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "m" | CHECKIT = "n" | CHECKIT = "o" | CHECKIT = "p" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "q" | CHECKIT = "r" | CHECKIT = "s" | CHECKIT = "s" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "t" | CHECKIT = "u" | CHECKIT = "v" | CHECKIT = "w" THEN DO
        FLAGIT = 1
    END
    IF CHECKIT = "x" | CHECKIT = "y" | CHECKIT = "z" THEN DO
        FLAGIT = 1
    END

    IF CHECKIT = "~" | CHECKIT = "`" | CHECKIT = "^" | CHECKIT = "_" | CHECKIT = "|" THEN DO
        FLAGIT = 2
    END

    IF CHECKIT = "{" | CHECKIT = "}" | CHECKIT = "[" | CHECKIT = "]" | CHECKIT = "<" | CHECKIT = ">" THEN DO
        FLAGIT = 2
    END

    IF FLAGIT = 1 THEN DO
            OK = VRMESSAGE("WINDOW1", "You cannot use lowercase letters in this program!", "Not All Characters are Machinable!", "I")
            OK = LINEOUT(PATH)
            OK = VRDELETEFILE(PATH)
            OK = VRMETHOD("LETTERS", "SETFOCUS")
            RETURN
    END    

    IF FLAGIT = 2 THEN DO
            OK = VRMESSAGE("WINDOW1", "You cannot use" CHECKIT" in this program!", "Not All Characters are Machinable!", "I")
            OK = LINEOUT(PATH)
            OK = VRDELETEFILE(PATH)
            OK = VRMETHOD("LETTERS", "SETFOCUS")
            RETURN
    END    


    OK = LINEOUT(PATH, TEMP)
    COUNTER = COUNTER + 1
    END


OK = LINEOUT(PATH, "~")
OK = LINEOUT(PATH)


THICKNESS = VRGET("MATERIAL", "VALUE")
CHECK_THICK = DATATYPE(THICKNESS)
IF CHECK_THICK <> NUM THEN DO
    OK = VRMESSAGE("WINDOW1", "The material thickess entry must be a number.", "Material Thickness Value", "E")
    OK = VRMETHOD("MATERIAL", "SETFOCUS")
    RETURN
END

PASSES = VRGET("PASSES", "SELECTED")
IF PASSES = 0 THEN DO
    PASSES = 1
END
STR2 = PASSES

CALL QUIT
return

/*:VRX         PB_2_Click
*/
PB_2_Click:

PATH = "C:\SYSTEM\LETTERS.TXT"

OK = LINEOUT(PATH, "~")
OK = LINEOUT(PATH)

CALL QUIT

return

/*:VRX         PB_3_Click
*/
PB_3_Click:

window = VRLoad( "Window1", "letters.vrw", "window2" )
ok = VRMethod( "window2", "Activate" )
ok = VRMethod( "PB_4", "SetFocus" )

return

/*:VRX         PB_4_Click
*/
PB_4_Click:

ok = VRDestroy( window2 )

return

/*:VRX         PB_5_Click
*/
PB_5_Click:

THE_TEXT = VRGET("LETTERS", "VALUE")
LETTER_LENGTH = LENGTH(THE_TEXT)
MTHICK = VRGET("MATERIAL", "VALUE")

PASS = VRGET("PASSES", "SELECTED")
IF PASS = 0 THEN DO
    PASS = 1
END

PERPASS = MTHICK / PASS

window = VRLoad( "Window1", "letters.vrw", "window3" )
ok = VRMethod( "window3", "Activate" )
ok = VRMethod( "PB_6", "SetFocus" )
OK = VRSET("ZLAB", "CAPTION", MTHICK)

IF LETTER_LENGTH > 1 THEN DO
    THE_TOTAL = (2.15 * (LETTER_LENGTH - 1)) + 2.06
    OK = VRSET("XLAB", "CAPTION", THE_TOTAL)
END

IF LETTER_LENGTH = 1 THEN DO
    OK = VRSET("XLAB", "CAPTION", "2.06")
END

IF LETTER_LENGTH < 1 THEN DO
    OK = VRMESSAGE("WINDOW1", "You must enter at least one machinable character! Choose the 'Machinable Characters' button to see a list of all supported characters.   ", "Nothing to Machine!", "W")
END
   
OK = VRSET("ZONE", "CAPTION", LETTER_LENGTH)
OK = VRSET("PERIMETER", "CAPTION", PASS)
OK = VRSET("PERPASS", "CAPTION", PERPASS)
return

/*:VRX         PB_6_Click
*/
PB_6_Click:

ok = VRDestroy( window3 )

return

/*:VRX         Quit
*/
Quit:
    window = VRWindow()
    call VRSet window, "Shutdown", 1
    drop window
return

/*:VRX         Window1_Close
*/
Window1_Close:
    call Quit
return

/*:VRX         window2_Close
*/
window2_Close:

call Quit

return
/*:VRX         window3_Close
*/
window3_Close:
    window = VRInfo( "Object" )
    call VRDestroy window
    drop window
return
